#include<reg51.h>   
#include<intrins.h> 
#define DATA P1
#define u8 unsigned char
#define u16 unsigned int
sbit RS=P2^0;         
sbit RW=P2^1;          
sbit EN=P2^2;             
sbit DQ=P2^7;
sbit k1=P2^4;
sbit k2=P2^5;
u8 time;
u16 x=15;
u8 y;
int wendu[]={0,1,2,3,4,5,6,7,8,9};
void delay1ms();
void Delaynms(u8 n);
void LCD_Write_Command(u8 cmd);
void LCD_Wdat(u8 dat);
void Init_LCD();
void display(u16 sg);
void Init_DS18B20(void);
u8 ReadOneChar(void);
void WriteOneChar(u8 dat);
u16 ReadyReadTemp(void);
   
		float tt;
 		u16 Temp;
		u8 H,L ;  
		Temp1=0x0000;
void delay(u16 t)
{
for(;t>0;t--);
}

void delay1ms(void)   
{
    unsigned char a,b;
    for(b=199;b>0;b--)
        for(a=1;a>0;a--);
}

void Delaynms(u8 n)
 {
   u8 i;
	for(i=0;i<n;i++)
	   delay1ms();
 }
void LCD_Write_Command(u8 cmd)
{
	RS=0;
	RW=0;
	EN=0;
	_nop_();
	_nop_();
	DATA=cmd;
	Delaynms(1);
	EN=1;
	Delaynms(1);
	EN=0;	
}
void LCD_Wdat(u8 dat)
{
	RS=1;
	RW=0;
	EN=0;
	DATA=dat;
	Delaynms(1);
	EN=1;
	Delaynms(1);
	EN=0;
}
void Init_LCD()
{
	LCD_Write_Command(0x02);Delaynms(1);
	LCD_Write_Command(0x06);Delaynms(1);
	LCD_Write_Command(0x0c);Delaynms(1);
	LCD_Write_Command(0x38);Delaynms(1);
	LCD_Write_Command(0x01);Delaynms(1);
}
void display(u16 sg)
{
	u8 a,b,c;
	a=sg/100;
	b=(sg%100)/10;
	c=sg%10;
	LCD_Write_Command(0x80);
	LCD_Wdat(a+0x30);
	LCD_Wdat(b+0x30);
	LCD_Wdat('.');
	LCD_Wdat(c+0x30);
}
void Init_DS18B20(void)
{
char presence=1;
while(presence)
{
while(presence)
{
DQ=1;_nop_();_nop_();
DQ=0;   
delay(50); 
DQ=1;   
delay(6); 
presence=DQ;
   }
delay(45);   
presence = ~DQ;
}
DQ=1;
} 

void WriteOneChar(u8 val)
{
u8 i;
for (i=8; i>0; i--) 
{
DQ=1;_nop_();_nop_(); 
DQ = 0;_nop_();_nop_();_nop_();_nop_();_nop_();
DQ = val&0x01;     
delay(6);         
val=val/2;         
}
DQ = 1;
delay(1); 
}

u8 ReadOneChar(void)
{
u8 i;
u8 value = 0;
for (i=8;i>0;i--)
{
DQ=1;_nop_();_nop_();
value>>=1;
DQ = 0;           
_nop_();_nop_();_nop_();_nop_();   
DQ = 1;_nop_();_nop_();_nop_();_nop_();   
if(DQ)value|=0x80;
delay(6);          
}
DQ=1;
return(value);
}
u16 ReadyReadTemp(void)
{  
		Init_DS18B20();     
		WriteOneChar(0xCC); 
		WriteOneChar(0x44);  
	  delay1ms();
		Init_DS18B20();    
		WriteOneChar(0xCC);
		WriteOneChar(0xBE); 
		L=ReadOneChar();
		H=ReadOneChar();
		Temp1=H;
		Temp1<<=8;
		Temp1|=L;
		tt=Temp1*0.0625;
		Temp1=tt*10+0.5;
		return (Temp1);
}
void main()
{
	u16 Temperature;
	Init_LCD();
        k1=0;
        k2=0;
	while(1)
	{
		Temperature=ReadyReadTemp();
		display(Temperature);
		Delaynms(1);
		y=Temperature/10;
                 y=wendu[y/10]*10+wendu[y%10];
                if(y<=x)
               {k1=0;
                k2=1;}
                else
               {k1=1;
                k2=0;}
                  }}



